@ECHO OFF

:: "casova" smycka (informacni "cekaci" okno, informujici o praci jineho procesu)
:: zobrazovane/ukoncovane na zaklade existence/neexistence semaforu "flag-soubor"
:: ******************************************************************************
:: vstupni parametry: - nazev smycky
::                    - mutace "en/cz"
::                    - potvrzovaci znak pro dialog "pause" - "Y/A"
:: vystupni parametry:
:: pozn: - nazev smycky - rof, rop, rdf, rdp, tenv, junc, foun, sort, math - jde 
::                        o nazev (identifikaci) semaforu "flag-soubor"
::       - "en/cz" - mutace ("en/cz"), podle ktere se ridi velikost okna a jazyk,
::                   ve kterem je veskery text okna vypisovan (v CR volit "cz")
::                 - potvrzovaci znak "Y/A" volit podle mutace processoru
::                   "cmd.exe" - je-li v prostredi "command line" vypisovano
::                   "Terminate batch job (Y/N)?", volit "Y", jinak "A" 
::       - je povinnosti uzivatele, aby tento spusteny task ukoncoval (vzdy ale
::         ale spustit vice ruznych procesu (smycek) najednou)
::
SETLOCAL EnableExtensions
SETLOCAL EnableDelayedExpansion
:: "zluta na cerne"
COLOR 0a
TITLE loop_wait_%1_%2

:: deklarace globalnich promennych, pouzitych pri volani subroutine:
:: - je-li pri volani subroutine prikazem CALL pouzit parametr, ktery
::   bude parametrem vystupnim, musi byt pred volanim deklarovan (a pri
::   volani musi byt pouzito jeho jmeno)
:: - ciselne poradi "p" parametru pri volani subroutine je pak pouzite
::   v prikazu "SET %p=...", kde pro "p" musi platit 0 < "p" <= 9 a musi
::   odpovidat poradi parametru pri volani
:: - opomenuti deklarace parametru pred volanim "CALL" (napr. prikazem
::   SET "nazev=" nebo SET nazev=0) vyvola chybu
:: - ve volane subroutine je vzdy mozne vracet hodnotu primo prikazem
::   "SET=..." s "procentovou" promennou "%p" ("0 < "p" <= 9")
SET pismenko=t h e q u i c k f o x l z y g s p j n m w r v d
SET "stopwatch="
SET /A stopwatch_n=0
SET I_t=N
SET "I_dot="
SET I_dot_w=.
SET /A n_dot=0


:: *****
:: START
:: *****

:: rozskok podle "en/cz"
GOTO num_col_%2

:num_col_en
SET num_col=92
GOTO all_mode

:num_col_cz
SET num_col=80
GOTO all_mode

:num_col_xy
SET num_col=96
GOTO all_mode

:all_mode
:: nastaveni rozmeru okna - pocet sloupcu a radku
MODE CON:COLS=%num_col% LINES=6
SET "w_spa="

:: nastaveni odpovedi pro "pause"
:: rozskok podle "Y/A/X"
GOTO w_%3

:w_Y
SET YA=Y^|y
GOTO en_cz

:w_A
SET YA=A^|a
GOTO en_cz

:w_X
SET YA=Y^|y^|A^|a
SET "w_spa=                "
GOTO en_cz

:en_cz
:: spusteni "stopek"
:: *****************
CALL :watch_wait s stopwatch stopwatch_n

:cykl_time
:: existence flag-file, nastaveni mozne pocatecni "nuly" a zpracovani
:: pocatecniho (initializacniho) casu
IF NOT exist "%1_%pismenko%.txt" GOTO fin_WFU
SET t_ww=%TIME:~-11,8%
IF "%t_ww:~0,1%" == " " SET t_ww=0%t_ww:~1%
IF %I_t% == Y GOTO NO_time_ini
SET I_t=Y
SET t_wi=%t_ww%
GOTO NO_time_ini

:NO_time_ini
:: existence flag-file, nastaveni mozne pocatecni "nuly" a zpracovani
:: prubezneho casu
IF NOT exist "%1_%pismenko%.txt" GOTO fin_WFU
SET t_ww=%TIME:~-11,8%
IF "%t_ww:~0,1%" == " " SET t_ww=0%t_ww:~1%
SET t_wo=%t_ww%
:: odecet stavu "stopek"
:: *********************
CALL :watch_wait u stopwatch stopwatch_n

:cykl_dot
:: priprava "tecek" - vizualni upoutavka procesu, simulujiciho cekani
:: vypisovanim pribyvajiciho poctu "tecek" a URL: www.nemohouci.cz
IF %n_dot% GTR 10 SET "I_dot="&SET /A n_dot=0&GOTO cykl_dot
SET /A n_dot+=1
SET I_dot=%I_dot%%I_dot_w%
SET "I_dot_ww=%I_dot%]   www.nemohouci.cz"
CLS
:: rozskok podle "en/cz/xy"
GOTO czen_%2

:: en ("xy") mutace
:czen_en
:czen_xy
ECHO.
ECHO  * wait a few minutes                          %w_spa%%t_wi% - %t_wo% - %stopwatch%
ECHO  *
:: rozskok podle identifikace flag_file
GOTO ope_%1en

:ope_rofen
ECHO  * diversification folder                      %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_ropen
ECHO  * diversification partition                   %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_rdfen
ECHO  * removal folder                              %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_rdpen
ECHO  * removal content partition                   %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_tenven
ECHO  * the environment test                        %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_juncen
ECHO  * work with folders "junction"                %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_founen
ECHO  * finding folders "junction"                  %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_sorten
ECHO  * list of partitions                          %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_mathen
ECHO  * "mathematics"                               %w_spa%[%I_dot_ww%
GOTO int_cykl_w

:: cz mutace
:czen_cz
ECHO  * cekat i nekolik minut                       %t_wi% - %t_wo% - %stopwatch%
ECHO  *
:: rozskok podle identifikace flag_file
GOTO ope_%1cz
:ope_rofcz
ECHO  * diverzifikace slozky                        %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_ropcz
ECHO  * diverzifikace oddilu                        %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_rdfcz
ECHO  * odstraneni obsahu slozky                    %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_rdpcz
ECHO  * odstraneni obsahu oddilu                    %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_tenvcz
ECHO  * test prostredi                              %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_junccz
ECHO  * prace se slozkami "junction"                %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_founcz
ECHO  * hledani slozek "junction"                   %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_sortcz
ECHO  * seznam oddilu                               %w_spa%[%I_dot_ww%
GOTO int_cykl_w
:ope_mathcz
ECHO  * "matematika"                                %w_spa%[%I_dot_ww%
GOTO int_cykl_w

:int_cykl_w
ECHO  *
:: rozskok podle "en/cz/xy"
GOTO czen_%2_encz

:czen_en_encz
:czen_xy_encz
ECHO  * immediately finished? =^> in the "main" window enter "Ctrl+C" and "%YA% | N|n" and "Enter"
GOTO int_cykl

:czen_cz_encz
ECHO  * okamzite skoncit? =^> v "hlavnim" okne zadat "Ctrl+C" a "%YA% | N|n" a "Enter"
GOTO int_cykl

:: zpracovani cyklu v case
:int_cykl
SET /A count=0

:cykl_sec
:: cykl "umeleho" time-out cca 1,5 sec
IF %count% LSS 200 SET /A count+=1&GOTO cykl_sec
GOTO cykl_time

:fin_WFU
exit
GOTO :eof

:: subroutine "watch_wait"
:: ***********************
:: vystup casu ve tvaru [hh:mm:ss] (nastaveni initializace casu/urceni prubezneho casu)
:: ************************************************************************************
:: vstupni parametry: - "s/u" - start "stopek"/prubezny stav "stopek"
:: vystupni parametry: - rozdil mezi startem (parametr "s") a jinym volanim (parametr
::                       "u"), je to vlastne "cas stopek" prevedeny do tvaru [hh:mm:ss]
::                       nebo aktualni cas v numerickem tvaru (suma sekund), vzdy podle
::                       parametru "s/u"
::
:watch_wait
SET "w_stop_z="
:: vyber hodin, minut a sekund realneho casu, poskytnuteho od OS
:: vyber minut a sekund havaruje:
::   - data jsou vyhodnocena jako nenumericka (jde vzdy o
::     pocatecni "0" u minut nebo sekund = "8" nebo "9", protoze jsou poskytnute jako
::     oktalove cislice (pocatecni " " u hodin je v poradku)
::   - jde o chybu OS, osetrenou otestovanim na "0" a podle vysledku testu vyberem
::     jednoho/dvou znaku "casu" k numerickemu prevodu
::
IF "%TIME:~0,1%" == " " (
  SET /A I_h=%TIME:~1,1%
) ELSE (
  SET /A I_h=%TIME:~0,2%
)
IF %TIME:~3,1% == 0 (
  SET /A I_m=%TIME:~4,1%
) ELSE (
  SET /A I_m=%TIME:~3,2%
)
IF %TIME:~6,1% == 0 (
  SET /A I_s=%TIME:~7,1%
) ELSE (
  SET /A I_s=%TIME:~6,2%
)
:: rozskok podle "s/u"
GOTO watch_%1

:watch_s
:: prevod na sekundy, initializace casu pro dalsi mozne volani s parametrem "u" a prevod
:: "0" sekund na znakovy tvar [hh:mm:ss]
SET /A i_stop_n=%I_h%*3600+%I_m%*60+%I_s%
SET /A w_stop_n=0
CALL :trans_NC %w_stop_n% t w_stop_z
GOTO fin_watch_wait

:watch_u
:: prevod na sekundy a zamena hodnot pri prechodu pres pulnoc - "absolutni" zdrzeni
SET /A w_stop_n=%I_h%*3600+%I_m%*60+%I_s%
IF NOT %w_stop_n% LSS %i_stop_n% GOTO ti_OK
SET /A s_ww=%i_stop_n%
SET /A i_stop_n=%w_stop_n%
SET /A w_stop_n=%s_ww%
GOTO ti:OK

:ti_OK
:: "rozdil" - uplynuly cas v sekundach - bude preveden na znaky, "slozen" do tvaru
:: [hh:mm:ss], kde vsechny tri udaje budou doplneny potrebnymi uvodnimi "nulami"
:: (muze dojit i ke stavu napr. [hh:00:0s]) a "prubezny cas stopek" (rozdil) bude
:: preveden do znakoveho tvaru
SET /A watch_stop=%w_stop_n%-%i_stop_n%
CALL :trans_NC %watch_stop% t w_stop_z
GOTO fin_watch_wait

:fin_watch_wait
SET %2=%w_stop_z%
SET %3=%w_stop_n%
GOTO :eof

:: subroutine "trans_NC"
:: *********************
:: prevod cisla z numerickeho tvaru na tvar "casu" [hh:mm:ss] nebo na cislo ve znakovem tvaru
:: ******************************************************************************************
:: vstupni parametry: - cislo v numerickem tvaru
::                    - "t/n": t - cislo je chapano jako suma sekund odpovidajici realnemu 
::                                 casu - je prepocteno na hodiny/minuty/sekundy a prevedeno 
::                                 na tvar [hh:mm:ss], kde vsechny "casy" (tam, kde je to
::                                 potreba), budou doplnene uvodnimi nulami
::                             n - prevod "numerickeho" celeho cisla na znakove, ve kterem
::                                 budou odstranene mozne zbytecne uvodni "0"
:: vystupni parametry: podle indikace "t/n" tvar "casu"/retezec cifer ve znakovem tvaru
::
:trans_NC
::rozskok podle "t/n"
GOTO trans_%2

:: *** n ************
:trans_n
SET "tran_c="
IF NOT %1 == 0 SET /A tran_n=%1&SET /A tran_w=%1&GOTO cykl_tran
:: protoze vstupni hodnota je nulova, prevede se pouze tato "0"
SET /A tran_n=0
SET /A tran_w=0
GOTO last_tran 

:cykl_tran
IF %tran_n% LSS 10 GOTO last_tran
:: deleni "10" snizi rad vstupniho retezce (znakoveho "cisla") - prevadi se vzdy posledni cifra
SET /A tran_w=%tran_n%/10
SET /A w_rest=%tran_n%-%tran_w%*10
SET /A tran_n=%tran_w%
FOR %%T IN (0 1 2 3 4 5 6 7 8 9) DO (IF %w_rest% == %%T SET tran_c=%%T%tran_c%&GOTO fin_forNC1)

:fin_forNC1
GOTO cykl_tran

:last_tran
:: prevod zbytku z "tran_w" po poslednim deleni "10" 
FOR %%T IN (0 1 2 3 4 5 6 7 8 9) DO (IF %tran_w% == %%T SET tran_c=%%T%tran_c%&GOTO fin_forNC2)

:fin_forNC2
:odstraneni moznych zbytecnych uvodnich nul
CALL :NO_zero %tran_c% tran_c
SET %3=%tran_c%
GOTO all_trans

:: *** t ************
:trans_t
SET /A w_t=%1
SET "w_hms="
:: zpracovani hodin, munt a sekund a postupny prevod hodin, minut a sekund z numerickeho
:: do znakoveho tvaru, ve finale poskladaneho do tvaru: [hh:mm:ss]
SET /A w_h=%w_t%/3600
SET /A w_t=%w_t%-(%w_h%*3600)
SET /A w_m=%w_t%/60
SET /A w_s=%w_t%-(%w_m%*60)
CALL :trans_HMS %w_h% w_hms
SET t_c=[%w_hms%
CALL :trans_HMS %w_m% w_hms
SET t_c=%t_c%:%w_hms%
CALL :trans_HMS %w_s% w_hms
SET t_c=%t_c%:%w_hms%]
SET %3=%t_c%
GOTO all_trans

:all_trans
GOTO :eof

:: subroutine "trans_HMS"
:: **********************
:: prevod hodin/minut/sekund na dvojici znaku s potrebnymi uvodnimi nulami
:: ***********************************************************************
:: vstupni parametry: "hh/mh/ss" realneho casu v numerickem tvaru
:: vystupni parametry: "hh/mh/ss" ve znakovem tvaru s moznymi uvodnimi "0"
::
:trans_HMS
SET w_time=0
:: prevod poctu "desitek"
SET /A w_desjed=%1/10
FOR %%T IN (0 1 2 3 4 5) DO (IF %w_desjed% == %%T SET w_time=%%T&GOTO fin_forHMS1)

:fin_forHMS1
:: prevod poctu "jednotek"
SET /A w_desjed=%1-%w_desjed%*10
FOR %%T IN (0 1 2 3 4 5 6 7 8 9) DO (IF %w_desjed% == %%T SET w_time=%w_time%%%T&GOTO fin_forHMS2)

:fin_forHMS2
SET %2=%w_time%
GOTO all_tran

:all_tran
GOTO :eof

:: interni subroutine "NO_zero"
:: ****************************
:: odstraneni moznych zbytecnych uvodnich "0" z retezce cifer ve "znakovem" tvaru
:: ******************************************************************************
:: vstupni parametry: retezec znaku 
:: vystupni parametry: retezec bez moznych zbytecnych uvodnich "0"
:: pozn.: - z bufferu jsou predem odstraneny vsechny znaky '"'
::        - je-li v retezci alespon jedna " " nebo je "prazdny", je nutne ho pred
::          volanim "balit" do dvojice znaku '"'
::        - vysledny retezec je: - tentyz
::                               -   -"-  bez uvodnich "0"
::                               - tvoreny jednou znakovou "0"
::                               - "prazdny"
::
:NO_zero
:: odstraneni '"'
SET no_ze=%~1
GOTO cykl_no_ze

:cykl_no_ze
:: - pokud je retezec prazdny nebo se znak nerovna "0" nebo se rovna a je jediny,
::   cykl konci
:: - jinak je znak odstranen a zpracovava se dalsi
IF "%no_ze%" == "" SET "no_ze="&GOTO fin_zero
IF NOT "%no_ze:~0,1%" == "0" GOTO fin_zero
IF "%no_ze:~1,1%" == "" GOTO fin_zero
:: =========================
IF %I_zer% == Y ECHO %no_ze%
:: odstraneni znaku a pokracovani cyklu proverenim dalsi mozne "0"
SET no_ze=%no_ze:~1%
GOTO cykl_no_ze

:fin_zero
SET %2=%no_ze%
GOTO :eof